Arch MeshToShape: Difference between revisions

From FreeCAD Documentation
m (languages)
(Marked this version for translation)
(34 intermediate revisions by 6 users not shown)
Line 1: Line 1:
<languages/>
{{GuiCommand|Name=Arch MeshToShape|Workbenches=[[Arch Module|Arch]]|MenuLocation=Arch -> Conversion Tools -> Mesh to Shape|SeeAlso=[[Arch RemoveShape]]}}
<translate>
<!--T:11-->
{{docnav
|[[Arch_SplitMesh|Split Mesh]]
|[[Arch_SelectNonSolidMeshes|Select non-solid meshes]]
|[[Arch_Module|Arch]]
|IconL=Arch_SplitMesh.svg
|IconC=Workbench_Arch.svg
|IconR=Arch SelectNonManifold.svg
}}


<!--T:1-->
==Description==
{{GuiCommand
|Name=Arch MeshToShape
|MenuLocation=Arch → Utilities → Mesh to Shape
|Workbenches=[[Arch Module|Arch]]
|SeeAlso=[[Arch SplitMesh|Arch SplitMesh]], [[Arch RemoveShape|Arch RemoveShape]]
}}


==Description== <!--T:2-->
This tool converts a selected [[Mesh Module|Mesh]] object into a [[Part Module|Shape]] object. Note that this tool is optimized for objects with flat faces (no curves). The corresponding tool from the [[Part Workbench]] might be more suited for objects that contain curved surfaces.


<!--T:3-->
==How to use==
[[Arch_MeshToShape|Arch MeshToShape]] converts a selected [[Mesh|Mesh]] ([[Mesh_Feature|Mesh Feature]]) object into a [[Shape|Shape]] ([[Part_Feature|Part Feature]]) object.


<!--T:17-->
# Select a mesh object
This tool is optimized for objects with flat faces (no curves). The corresponding tool {{Button|[[File:Part_ShapeFromMesh.svg|16px]] [[Part_ShapeFromMesh|Part ShapeFromMesh]]}} from the [[Image:Workbench_Part.svg|16px]] [[Part_Module|Part Workbench]] might be more suited for objects that contain curved surfaces.
# Press the {{KEY|[[Image:Arch MeshToShape.png|16px]] '''Mesh to Shape'''}} entry in Arch -> Conversion Tools menu


==Usage== <!--T:4-->
==Scripting==


<!--T:5-->
This tool can by used in [[macros]] and from the python console by using the following function:
# Select a mesh object.
# Press the {{Button|[[Image:Arch MeshToShape.svg|16px]] [[Arch MeshToShape|Mesh to Shape]]}} entry in {{MenuCommand|Arch Utilities Mesh to Shape}}.


==Properties== <!--T:15-->
'''meshToShape (object,[mark])''': turns a mesh into a shape, joining coplanar facets. If
mark is True (default), non-solid objects will be marked in red


==Limitations== <!--T:16-->


==Scripting== <!--T:6-->
{{languages | {{it|Arch MeshToShape/it}} }}
{{Emphasis|See also:}} [[Arch API|Arch API]] and [[FreeCAD Scripting Basics|FreeCAD Scripting Basics]].

<!--T:7-->
This tool can be used in [[macros|macros]] and from the [[Python|Python]] console by using the following function:
</translate>
{{Code|code=
new_obj = meshToShape(obj, mark=True, fast=True, tol=0.001, flat=False, cut=True)
}}
<translate>

<!--T:8-->
The above code snippet converts the given {{incode|obj}} (a mesh), into a shape, joining coplanar facets.
* If {{incode|mark}} is {{incode|True}}, non-solid objects will be marked in red.
* If {{incode|fast}} is {{incode|True}}, it uses a faster algorithm by building a shell from the facets then removing splitter.
* {{incode|tol}} is the tolerance used when converting mesh segments to wires.
* If {{incode|flat}} is {{incode|True}}, it will force the wires to be perfectly planar to be sure they can be converted into faces, but this might leave gaps in the final shell.
* If {{incode|cut}} is {{incode|True}}, holes in faces are made by subtraction.

<!--T:18-->
Example:
</translate>
{{Code|code=
import Arch, Mesh, BuildRegularGeoms

Box = FreeCAD.ActiveDocument.addObject("Mesh::Cube", "Cube")
Box.Length = 1000
Box.Width = 2000
Box.Height = 1000
FreeCAD.ActiveDocument.recompute()

new_obj = Arch.meshToShape(Box)
}}
<translate>

<!--T:12-->
{{docnav
|[[Arch_SplitMesh|Split Mesh]]
|[[Arch_SelectNonSolidMeshes|Select non-solid meshes]]
|[[Arch_Module|Arch]]|IconL=Arch_SplitMesh.svg
|IconC=Workbench_Arch.svg
|IconR=Arch SelectNonManifold.svg
}}

</translate>
{{Arch Tools navi{{#translation:}}}}
{{Userdocnavi{{#translation:}}}}

Revision as of 12:13, 6 March 2020

Arch MeshToShape

Menu location
Arch → Utilities → Mesh to Shape
Workbenches
Arch
Default shortcut
None
Introduced in version
-
See also
Arch SplitMesh, Arch RemoveShape

Description

Arch MeshToShape converts a selected Mesh (Mesh Feature) object into a Shape (Part Feature) object.

This tool is optimized for objects with flat faces (no curves). The corresponding tool Part ShapeFromMesh from the Part Workbench might be more suited for objects that contain curved surfaces.

Usage

  1. Select a mesh object.
  2. Press the Mesh to Shape entry in Arch → Utilities → Mesh to Shape.

Properties

Limitations

Scripting

See also: Arch API and FreeCAD Scripting Basics.

This tool can be used in macros and from the Python console by using the following function:

new_obj = meshToShape(obj, mark=True, fast=True, tol=0.001, flat=False, cut=True)

The above code snippet converts the given obj (a mesh), into a shape, joining coplanar facets.

  • If mark is True, non-solid objects will be marked in red.
  • If fast is True, it uses a faster algorithm by building a shell from the facets then removing splitter.
  • tol is the tolerance used when converting mesh segments to wires.
  • If flat is True, it will force the wires to be perfectly planar to be sure they can be converted into faces, but this might leave gaps in the final shell.
  • If cut is True, holes in faces are made by subtraction.

Example:

import Arch, Mesh, BuildRegularGeoms

Box = FreeCAD.ActiveDocument.addObject("Mesh::Cube", "Cube")
Box.Length = 1000
Box.Width = 2000
Box.Height = 1000
FreeCAD.ActiveDocument.recompute()

new_obj = Arch.meshToShape(Box)